/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 27 janv. 2007 22:29:42

import java.util.Enumeration;

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.fwkcktldepense.server.factory.FactoryCommande;
import org.cocktail.fwkcktldepense.server.finder.FinderBudget;
import org.cocktail.fwkcktldepense.server.metier.EOBudgetExecCredit;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOCommandeBudget;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOTauxProrata;
import org.cocktail.fwkcktldepenseguiajax.serveur.controllers.CktlSourceSelectionCtrl;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableArray;

public class SourceListeSelection extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	//	NSArray<EOConvention> lesConventions = null;
	//	EOConvention uneConvention = null, uneConventionSelectionnee = null;
	//	private String filterTextConventions = null;
	//	private NSDictionary<String, Object> uneSourceUtilisateur = null;
	private NSMutableArray<NSDictionary<String, Object>> lesSourcesUtilisateurSelectionnees = null;
	//	private NSArray<NSDictionary<String, Object>> lesSourcesUtilisateur = null;
	//	private NSArray<NSDictionary<String, Object>> lesSourcesUtilisateurAAfficher = null;
	//	private NSMutableDictionary<String, Object> bdgsSourcesUtilisateur = new NSMutableDictionary<String, Object>();
	//	private boolean isAfficherCreditsPreferesDisabled = false;
	//	private boolean isAfficherCreditsPreferes = true;
	//	private boolean isAfficherCreditsParConvention = false;
	//	private boolean isAfficherCreditsDisponibles = false;
	//	private boolean isAfficherTousCredits = false;

	protected CktlSourceSelectionCtrl sourceSelectionCtrl;

	public SourceListeSelection(WOContext context) {
		super(context);
	}

	public WOComponent neFaitRien() {
		return null;
	}

	public WOActionResults ajouterLesSourcesSelectionnees() {
		FactoryCommande fc = session.getFactoryCommande();
		EOCommande laCommande = laCommandeEnCours();
		NSMutableArray<NSDictionary<String, Object>> sources = getLesSourcesUtilisateurSelectionnees();
		NSArray<EOBudgetExecCredit> credits = FinderBudget.getBudgets(laCommande.editingContext(), sources);
		if (credits != null && credits.count() > 0) {
			Enumeration<EOBudgetExecCredit> enumCredits = credits.objectEnumerator();

			while (enumCredits.hasMoreElements()) {
				EOBudgetExecCredit credit = (EOBudgetExecCredit) enumCredits.nextElement();
				NSArray<EOTauxProrata> lesTaux = credit.getTauxProratas(laCommande.editingContext());
				if (lesTaux != null && lesTaux.count() > 0) {
					EOTauxProrata unTaux = (EOTauxProrata) lesTaux.objectAtIndex(0);
					if (unTaux != null) {
						fc.ajouterSource(laCommande.editingContext(), laCommande, credit, unTaux);
						//Si preselection taux de prorata est desactivee
						if (!myApp().preselectionTauxProrata().booleanValue()) {
							if (lesTaux.count() > 1) {
								EOCommandeBudget commandeBudget = laCommande.containsSource(credit.organ(), credit.typeCredit());
								if (commandeBudget != null) {
									commandeBudget.setTauxProrataRelationship(null);
								}
							}
						}

					}
				}
			}
		}
		return NavigationCtrl.goToSavedBonDeCommande(session, laCommande, null, "Sources");
	}

	public EOEditingContext getEditingContext() {
		EOCommande laCommande = laCommandeEnCours();
		EOEditingContext edc = laCommande.editingContext();
		return edc;
	}

	//
	//	public WOComponent ajouterUneSourceAuxPreferes() {
	//		NSDictionary<String, Object> uneSource = getUneSourceUtilisateur();
	//		//EOCommande laCommande = laCommandeEnCours();
	//		//EOEditingContext edc = laCommande.editingContext();
	//		EOEditingContext edc = getEditingContext();
	//		NSArray<EOBudgetExecCredit> credits = FinderBudget.getBudgets(edc, new NSArray<NSDictionary<String, Object>>(uneSource));
	//		if (credits != null && credits.count() > 0) {
	//			@SuppressWarnings("unchecked")
	//			NSArray<EOOrgan> organs = (NSArray<EOOrgan>) credits.valueForKeyPath("organ");
	//			ProcessPreference.insererOrgansPreferes(session.dataBus(), utilisateurInContext(edc), organs);
	//			isAfficherCreditsPreferesDisabled = false;
	//			filtrer1SourcesUtilisateur();
	//		}
	//
	//		return null;
	//	}
	////
	//	public WOComponent supprimerSourcePreferee() {
	//		NSDictionary<String, Object> uneSource = getUneSourceUtilisateur();
	//		//EOCommande laCommande = laCommandeEnCours();
	//		//EOEditingContext edc = laCommande.editingContext();
	//		EOEditingContext edc = getEditingContext();
	//		NSArray<EOBudgetExecCredit> credits = FinderBudget.getBudgets(edc, new NSArray<NSDictionary<String, Object>>(uneSource));
	//		if (credits != null && credits.count() > 0) {
	//			@SuppressWarnings("unchecked")
	//			NSArray<EOOrgan> organs = (NSArray<EOOrgan>) credits.valueForKeyPath("organ");
	//			ProcessPreference.supprimerOrgansPreferes(session.dataBus(), utilisateurInContext(edc), organs);
	//			filtrer1SourcesUtilisateur();
	//		}
	//
	//		return null;
	//	}

	public WOActionResults annuler() {
		reset();
		return null;
	}

	/*
	 * public boolean isEligible() { boolean isEligible = false; NSDictionary<String, Object> laSource = getUneSourceUtilisateur(); if (laSource !=
	 * null) { Double disponible = (Double) laSource.objectForKey("DISPONIBLE"); Double isProrata = (Double) laSource.objectForKey("ISPRORATA");
	 * Double isDroit = (Double) laSource.objectForKey("DROIT"); if ((disponible.doubleValue() > 0) && (isProrata.doubleValue() > 0) &&
	 * isDroit.doubleValue() == 1) { isEligible = true; } } return isEligible; }
	 */

	//	public NSDictionary<String, Object> getUneSourceUtilisateur() {
	//		return uneSourceUtilisateur;
	//	}
	//
	//	public void setUneSourceUtilisateur(NSDictionary<String, Object> uneSource) {
	//		this.uneSourceUtilisateur = uneSource;
	//	}

	public NSMutableArray<NSDictionary<String, Object>> getLesSourcesUtilisateurSelectionnees() {
		return getSourceSelectionCtrl().getLesSourcesUtilisateurSelectionnees();
		//return lesSourcesUtilisateurSelectionnees;
	}

	//	public void setLesSourcesUtilisateurSelectionnees(NSMutableArray<NSDictionary<String, Object>> lesSourcesSelectionnees) {
	//		this.lesSourcesUtilisateurSelectionnees = lesSourcesSelectionnees;
	//	}

	//
	//	public NSMutableDictionary<String, Object> getBdgsSourcesUtilisateur() {
	//		return bdgsSourcesUtilisateur;
	//	}
	//
	//	public void setBdgsSourcesUtilisateur(NSMutableDictionary<String, Object> bdgsSourcesUtilisateur) {
	//		this.bdgsSourcesUtilisateur = bdgsSourcesUtilisateur;
	//	}
	//
	//	public NSArray<NSDictionary<String, Object>> getLesSourcesUtilisateur() {
	//		return lesSourcesUtilisateur;
	//	}

	protected EOExercice getExercice() {
		return laCommandeEnCours().exercice();
	}

	//	protected NSArray<NSDictionary<String, Object>> getRawRowBudgets(EOEditingContext ed, NSMutableDictionary<String, Object> bindings) {
	//		return FinderBudget.getRawRowBudgets(ed, bindings);
	//	}

	//
	//	public WOComponent filtrerSourcesUtilisateur() {
	//		NSMutableDictionary<String, Object> bdgs = getBdgsSourcesUtilisateur();
	//		if (bdgs.count() > 0) {
	//			//EOCommande commande = laCommandeEnCours();
	//			EOConvention conv = (EOConvention) bdgs.objectForKey("convention");
	//			if (conv != null) {
	//				//				EOEditingContext ed = commande.editingContext();
	//				EOEditingContext ed = getEditingContext();
	//				//EOExercice exercice = laCommandeEnCours().exercice();
	//				EOExercice exercice = getExercice();
	//				NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
	//				bindings.setObjectForKey(exercice, "exercice");
	//				bindings.setObjectForKey(conv, "convention");
	//				bindings.setObjectForKey(utilisateurInContext(ed), "utilisateur");
	//				//				lesSourcesUtilisateur = FinderBudget.getRawRowBudgets(ed, bindings);
	//				lesSourcesUtilisateur = getRawRowBudgets(ed, bindings);
	//				lesSourcesUtilisateurAAfficher = lesSourcesUtilisateur;
	//			}
	//			else {
	//				String ub = (String) bdgs.objectForKey("organUb");
	//				String cr = (String) bdgs.objectForKey("organCr");
	//				String sscr = (String) bdgs.objectForKey("organSsCr");
	//				String tc = (String) bdgs.objectForKey("tcdCode");
	//
	//				NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
	//				if (ub != null && ub.equals("") == false) {
	//					//EOQualifier ubQual = EOQualifier.qualifierWithQualifierFormat("ORGANUB like %@", new NSArray(ub + "*"));
	//					EOQualifier ubQual = ERXQ.like("ORGANUB", ub + "*");
	//
	//					qualifiers.addObject(ubQual);
	//				}
	//				if (cr != null && cr.equals("") == false) {
	//					//EOQualifier crQual = EOQualifier.qualifierWithQualifierFormat("ORGANCR caseInsensitiveLike %@", new NSArray(cr + "*"));
	//					EOQualifier crQual = ERXQ.likeInsensitive("ORGANCR", cr + "*");
	//					qualifiers.addObject(crQual);
	//				}
	//				if (sscr != null && sscr.equals("") == false) {
	//					//EOQualifier sscrQual = EOQualifier.qualifierWithQualifierFormat("ORGANSSCR caseInsensitiveLike %@", new NSArray(sscr + "*"));
	//					EOQualifier sscrQual = ERXQ.likeInsensitive("ORGANSSCR", sscr + "*");
	//					qualifiers.addObject(sscrQual);
	//				}
	//				if (tc != null && tc.equals("") == false) {
	//					//EOQualifier tcQual = EOQualifier.qualifierWithQualifierFormat("TYPECREDIT like %@", new NSArray(tc + "*"));
	//					EOQualifier tcQual = ERXQ.like("TYPECREDIT", tc + "*");
	//					qualifiers.addObject(tcQual);
	//				}
	//				EOAndQualifier qualFiltre = new EOAndQualifier(qualifiers);
	//				lesSourcesUtilisateurAAfficher = EOQualifier.filteredArrayWithQualifier(lesSourcesUtilisateur, qualFiltre);
	//			}
	//		}
	//		else {
	//			filtrer1SourcesUtilisateur();
	//		}
	//		return null;
	//	}
	//
	//	public WOComponent filtrer1SourcesUtilisateur() {
	//		EOEditingContext ed = getEditingContext();
	//
	//		NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
	//		bindings.setObjectForKey(utilisateurInContext(ed), "utilisateur");
	//		bindings.setObjectForKey(getExercice(), "exercice");
	//		lesSourcesUtilisateur = null;
	//
	//		if (isAfficherCreditsParConvention() == false && isAfficherTousCredits == false) {
	//			getBdgsSourcesUtilisateur().removeAllObjects();
	//			filterTextConventions = null;
	//			if (isAfficherCreditsPreferes() == true) {
	//				bindings.setObjectForKey(Boolean.TRUE, "lignesPreferees");
	//				lesSourcesUtilisateur = getRawRowBudgets(ed, bindings);
	//				if (isAfficherCreditsPreferes() == true && lesSourcesUtilisateur.count() == 0) {
	//					isAfficherCreditsPreferesDisabled = true;
	//					isAfficherCreditsPreferes = false;
	//					isAfficherCreditsDisponibles = true;
	//				}
	//			}
	//			if (isAfficherCreditsDisponibles() == true) {
	//				bindings.removeObjectForKey("lignesPreferees");
	//				bindings.setObjectForKey(Boolean.TRUE, "creditsDispo");
	//				lesSourcesUtilisateur = getRawRowBudgets(ed, bindings);
	//			}
	//		}
	//		else {
	//			lesSourcesUtilisateur = getRawRowBudgets(ed, bindings);
	//		}
	//		lesSourcesUtilisateurAAfficher = lesSourcesUtilisateur;
	//
	//		return null;
	//	}
	//
	//	public void trierDispoSourcesUtilisateur() {
	//		NSArray<NSDictionary<String, Object>> sources = getLesSourcesUtilisateur();
	//		EOSortOrdering sortDispo = EOSortOrdering.sortOrderingWithKey(EOBudgetExecCredit.BDXC_DISPONIBLE_KEY, EOSortOrdering.CompareDescending);
	//		lesSourcesUtilisateur = EOSortOrdering.sortedArrayUsingKeyOrderArray(sources, new NSArray<EOSortOrdering>(sortDispo));
	//	}
	//
	//	public void setLesSourcesUtilisateur(NSArray<NSDictionary<String, Object>> lesSourcesUtilisateur) {
	//		this.lesSourcesUtilisateur = lesSourcesUtilisateur;
	//	}
	//
	//	public boolean isRechercherParConvention() {
	//		return isAfficherCreditsParConvention();
	//	}
	//
	//	public boolean isAfficherCreditsPreferesDisabled() {
	//		return isAfficherCreditsPreferesDisabled;
	//	}
	//
	//	public boolean isAfficherCreditsPreferes() {
	//		return isAfficherCreditsPreferes;
	//	}
	//
	//	public void setIsAfficherCreditsPreferes(boolean isAfficherCreditsPreferes) {
	//		this.isAfficherCreditsPreferes = isAfficherCreditsPreferes;
	//	}
	//
	//	public boolean isAfficherCreditsParConvention() {
	//		return isAfficherCreditsParConvention;
	//	}
	//
	//	public void setIsAfficherCreditsParConvention(boolean isAfficherCreditsParConvention) {
	//		this.isAfficherCreditsParConvention = isAfficherCreditsParConvention;
	//	}
	//
	//	public boolean isAfficherCreditsDisponibles() {
	//		return isAfficherCreditsDisponibles;
	//	}
	//
	//	public void setIsAfficherCreditsDisponibles(boolean isAfficherCreditsDisponibles) {
	//		this.isAfficherCreditsDisponibles = isAfficherCreditsDisponibles;
	//	}
	//
	//	public boolean isAfficherTousCredits() {
	//		return isAfficherTousCredits;
	//	}
	//
	//	public void setIsAfficherTousCredits(boolean isAfficherTousCredits) {
	//		this.isAfficherTousCredits = isAfficherTousCredits;
	//	}

	public boolean isAjouterDisabled() {
		boolean isAjouterDisabled = true;
		NSArray<NSDictionary<String, Object>> sources = getLesSourcesUtilisateurSelectionnees();
		if (sources != null && sources.count() > 0) {
			isAjouterDisabled = false;
		}
		return isAjouterDisabled;
	}

	//
	//	public NSArray<NSDictionary<String, Object>> getLesSourcesUtilisateurAAfficher() {
	//		if (lesSourcesUtilisateurAAfficher == null) {
	//			lesSourcesUtilisateurAAfficher = getLesSourcesUtilisateur();
	//			filtrer1SourcesUtilisateur();
	//		}
	//		return lesSourcesUtilisateurAAfficher;
	//	}
	//
	//	public void setLesSourcesUtilisateurAAfficher(NSArray<NSDictionary<String, Object>> lesSourcesUtilisateurAAfficher) {
	//		this.lesSourcesUtilisateurAAfficher = lesSourcesUtilisateurAAfficher;
	//	}
	//
	//	public NSArray<EOConvention> getLesConventions() {
	//		if (lesConventions == null) {
	//			EOEditingContext ed = getEditingContext();
	//			EOExercice exercice = FinderExercice.getExercicePourDate(ed, new NSTimestamp());
	//			NSDictionary<String, Object> bindings = new NSDictionary<String, Object>(exercice, "exercice");
	//			lesConventions = FinderConvention.getConventions(ed, bindings);
	//		}
	//		return lesConventions;
	//	}
	//
	//	public void setLesConventions(NSArray<EOConvention> lesConventions) {
	//		this.lesConventions = lesConventions;
	//	}
	//
	//	public EOConvention getUneConvention() {
	//		return uneConvention;
	//	}
	//
	//	public void setUneConvention(EOConvention uneConvention) {
	//		this.uneConvention = uneConvention;
	//	}
	//
	//	public EOConvention getUneConventionSelectionnee() {
	//		return uneConventionSelectionnee;
	//	}
	//
	//	public void setUneConventionSelectionnee(EOConvention uneConventionSelectionnee) {
	//		this.uneConventionSelectionnee = uneConventionSelectionnee;
	//	}
	//
	//	public String getFilterTextConventions() {
	//		return filterTextConventions;
	//	}
	//
	//	public void setFilterTextConventions(String filterTextConventions) {
	//		this.filterTextConventions = filterTextConventions;
	//	}

	public String getContainerBoutonId() {
		return getComponentId() + "_containerBoutons";
	}

	public CktlSourceSelectionCtrl getSourceSelectionCtrl() {
		if (sourceSelectionCtrl == null) {
			sourceSelectionCtrl = new CktlSourceSelectionCtrl(mySession(), getEditingContext(), getExercice());
		}
		return sourceSelectionCtrl;
	}

	public void setSourceSelectionCtrl(CktlSourceSelectionCtrl sourceSelectionCtrl) {
		this.sourceSelectionCtrl = sourceSelectionCtrl;
	}

}